package nc.impl.fip.relation;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

import com.alibaba.fastjson.JSONObject;

import nc.bs.arap.pay.bzfk.ImageCommonConstant;
import nc.bs.arap.pay.bzfk.api.ImageCaptureAPI;
import nc.bs.arap.pay.bzfk.tools.ImageCommonUtil;
import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.vo.arap.pay.bzfk.ImageTMLogVO;
import nc.vo.arap.pay.bzfk.InvoiceVo;
import nc.vo.arap.pay.bzfk.InvoicestatusVO;
import nc.vo.fip.relation.FipRelationVO;
import nc.vo.pub.BusinessException;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

/**
 * ƾ֤дӰ״̬
 * @date 2021-09-01
 * @author xuy
 * */
public class CredentialsWrite {
	private String[] src_billtypes= {"F1-Cxx-W02","F1-Cxx-W03","F1-Cxx-W04","F1-Cxx-W05"};
	public void write(List<InvoiceVo> vos) throws BusinessException {
		if(vos==null||vos.size()<=0) {
			return;
		}
		for(InvoiceVo vo : vos) {
			if(vo.getPk_voucher()!=null) {
			// ¼״̬
			List<InvoicestatusVO> invoiceStatusVOs = new ArrayList<InvoicestatusVO>();
			InvoicestatusVO invoiceStatusVO = new InvoicestatusVO();
			invoiceStatusVO.setInvoiceNo(vo.getFphm());
			invoiceStatusVO.setInvoiceCode(vo.getFpdm());
			invoiceStatusVO.setSalesbillNo(vo.getDjbh());
			invoiceStatusVO.setBusinessNo(vo.getNum());
			invoiceStatusVO.setBusinessType("4");
			invoiceStatusVO.setBusinessStatus("0");
			invoiceStatusVO.setBusinessDate(ImageCommonUtil.getStringDate(vo.getPrepareddate()));
			invoiceStatusVO.setSystemOrig("2");
			invoiceStatusVO.setBusinessRemark(vo.getPk_erminvoice());
			//xuyong  ӷƱֶ   20210705
			invoiceStatusVO.setTicketCode(vo.getDefitem10());
			invoiceStatusVO.setInvoiceId(vo.getDefitem11());
			invoiceStatusVO.setInvoiceType(vo.getDefitem3());
			//xuyong  ӷƱֶ   20210705
			invoiceStatusVOs.add(invoiceStatusVO);
			updateInvoiceStatus(invoiceStatusVOs);
			}
		}
	}
	
	
	
	public List<InvoiceVo> getInvoiceVos(FipRelationVO[] vos) throws DAOException{
		List<InvoiceVo> revos=new ArrayList<InvoiceVo>();
		List<String> ignoreList = Arrays.asList(src_billtypes);;
		for(FipRelationVO vo:vos) {
				if(!ignoreList.contains(vo.getSrc_billtype())) {
					continue;
				}
				String src_relationid=vo.getSrc_relationid();//ϵ  Դݹ 
				StringBuffer sqlbuff=new StringBuffer("");
				sqlbuff.append(" select  ap.pk_payablebill as PK_JKBX, ");
				sqlbuff.append(" case when ap.pk_tradetype='F1-Cxx-W02' then ap.def1 "
						+ "  else ap.billno end as DJBH,");
				sqlbuff.append(" u.user_code as USERCODE, ");	
				sqlbuff.append(" ap.local_money as ORGLOCAL, ");
				sqlbuff.append(" (case when ap.def3='Y' or ap.def29='Y' then 5 else 0 end) as SETTLESTATUS , ");
				sqlbuff.append(" vo.pk_voucher as PK_VOUCHER, ");
				sqlbuff.append("  to_char(vo.num) as NUM, ");
				sqlbuff.append("  vo.explanation as EXPLANATION, ");
				sqlbuff.append("   vo.ts as TS, ");
				sqlbuff.append("  inv.fpdm as FPDM, ");
				sqlbuff.append("  inv.fphm as FPHM, ");
				sqlbuff.append("  inv.pk_erminvoice as PK_ERMINVOICE , ");
				sqlbuff.append("  inv.defitem5 as DEFITEM5, ");
				sqlbuff.append("  inv.defitem6 as DEFITEM6, ");
				sqlbuff.append("  inv.defitem3 as DEFITEM3, ");
				sqlbuff.append("  inv.defitem10 as DEFITEM10, ");
				sqlbuff.append("  inv.defitem11 as DEFITEM11  ");
				sqlbuff.append("  from gl_voucher vo ");
				sqlbuff.append("  inner join fip_relation re  on re.des_relationid = vo.pk_voucher ");
				sqlbuff.append("  inner join ap_payablebill ap on ap.pk_payablebill=substr(re.SRC_RELATIONID,0,20) ");
				sqlbuff.append("  inner join sm_user u on ap.billmaker = u.cuserid ");
				sqlbuff.append("  inner join er_erminvoice inv on ap.pk_payablebill = inv.pk_bxdhead ");
				sqlbuff.append("  where re.DES_BILLTYPE = 'C0' and inv.defitem3<>'fj' ");
				sqlbuff.append("  and re.src_relationid='"+src_relationid+"' ");
				
				List<InvoiceVo> listvos = (List<InvoiceVo>) getBaseDao().executeQuery(sqlbuff.toString(), new BeanListProcessor(InvoiceVo.class));
				if(listvos!=null)
				revos.addAll(listvos);
			}
		return revos;
	}
	
	private void updateInvoiceStatus(List<InvoicestatusVO> invoiceStatusVOs) {
		if(null != invoiceStatusVOs && 0 < invoiceStatusVOs.size()) {
			for(InvoicestatusVO vo:invoiceStatusVOs) {
				String pk_erminvoice = vo.getBusinessRemark();
				vo.setBusinessRemark(null);
				JSONObject json = (JSONObject) JSONObject.toJSON(vo);
				try {
					JSONObject result = ImageCaptureAPI.postRequest(json, ImageCommonConstant.IMAGE_INVOICE_UPDATE);
					insertImageLog_RequiresNew(vo.getInvoiceNo(),null,json,result,ImageCommonConstant.IMAGE_INVOICE_UPDATE);
					String code = result.getString("code");
					if(!"200".equals(code)) {
						ExceptionUtils.wrappBusinessException("" + ImageCaptureAPI.map.get(ImageCommonConstant.IMAGE_INVOICE_UPDATE) 
						+ "ӿʧܣ" + result.get("message").toString());
					}
				}catch (Exception e) {
					ExceptionUtils.wrappException(e);
					}
			}
		}
		
	}
	public void insertImageLog_RequiresNew(String billid, String billcode, JSONObject send, JSONObject result, String urlcode) throws BusinessException {
		String code = result.getString("code");
		ImageTMLogVO log = new ImageTMLogVO();
		log.setBillid(billid);
		log.setBillno(billcode);
		log.setTm_content(JSONObject.toJSONString(send));
		log.setTm_result(JSONObject.toJSONString(result));
		log.setApicode(urlcode);
		if(!StringUtils.isBlank(code) && "200".equals(code)) {
			log.setTm_status("S");
		} else {
			log.setTm_status("F");
		}
		// ־
		getBaseDao().insertVO(log);
	}
	
	private BaseDAO baseDao = null;
	private BaseDAO getBaseDao() {
		if (baseDao == null)
			baseDao = new BaseDAO();
		return baseDao;
	}
}
